using System;
using System.Collections.Generic;
using System.Text;

namespace Fakultaet
{
    class Program
    {
        static void Main(string[] args)
        {
            double n = factorial_gleitkomma_iterativ(42);
            Console.WriteLine(n);
            Console.ReadLine();
        }

        static ulong factorial_ganzzahl_rekursiv(uint n)
        {
            // rekursiv
            if (n == 0)
            {
                return 1;
            }
            else
            {
                ulong result = 0;
                checked // prfe auf Ganzzahl-berlauf
                {
                    result = n*factorial_ganzzahl_rekursiv(n - 1);
                }
                return result;
            }
        }
        static double factorial_gleitkomma_rekursiv(uint n)
        {
            // rekursiv
            if (n == 0)
            {
                return 1;
            }
            else
            {
                return n * factorial_gleitkomma_rekursiv(n - 1);
            }
        }
        static double factorial_gleitkomma_iterativ(uint n)
        {
            double result = 1.0;
            for (int i = 2; i <= n; i++)
            {
                result *= i;
            }
            return result;
        }
    }
}
